Loading...
Searching...
No Matches
casacore::LCPagedMask Class Reference
lattices package (libcasa_lattices) » LRegions_module

More...

`#include <LCPagedMask.h>`

## Public Member Functions

| LCPagedMask ()
| LCPagedMask (const TiledShape &latticeShape, const String &tableName)
| Construct a PagedMask object for (part of) a lattice.
| LCPagedMask (const TiledShape &maskShape, const LCBox &box, const String &tableName)
| LCPagedMask (PagedArray< Bool > &mask, const LCBox &box)
| LCPagedMask (const LCPagedMask &other)
| Copy constructor (copy semantics).
virtual | ~LCPagedMask ()
| Destructor.
LCPagedMask & | operator= (const LCPagedMask &other)
| Assignment (reference semantics).
virtual Bool | operator== (const LCRegion &other) const
| Comparison.
virtual LCRegion * | cloneRegion () const
| Make a copy of the derived object.
virtual LatticeIterInterface< Bool > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| This function is used by the LatticeIterator class to generate an iterator of the correct type for this Lattice.
virtual uInt | advisedMaxPixels () const
| Returns the maximum recommended number of pixels for a cursor.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Help the user pick a cursor for most efficient access.
virtual uInt | maximumCacheSize () const
| Maximum size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be be big enough for the indicated number of tiles.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.
virtual void | handleDelete ()
| Handle deletion of the region by deleting the associated table.
virtual void | handleRename (const String &newName, Bool overwrite)
| Handle renaming the region by renaming the associated table.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle the (un)locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the PagedArray object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | type () const
| Region type.
virtual TableRecord | toRecord (const String &tableName) const
| Convert the (derived) object to a record.
virtual Bool | isWritable () const
| An LCPagedMask is writable if the underlying PagedArray is.
Public Member Functions inherited from casacore::LCRegionSingle
| LCRegionSingle ()
| LCRegionSingle (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegionSingle (const LCRegionSingle &other)
| Copy constructor (copy semantics).
virtual | ~LCRegionSingle ()
virtual Bool | hasMask () const
| Does the region have a mask?
const Array< Bool > | maskArray () const
| Get the mask (as an array).
Bool | masksEqual (const LCRegion &other) const
| Is the mask of this region the same as the mask of the other.
virtual void | set (const Bool &value)
| The following "put" functions are described in detail in class Lattice.
virtual void | apply (Bool(*function)(Bool))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (Bool(*function)(const Bool &))
virtual void | apply (const Functional< Bool, Bool > &function)
virtual void | putAt (const Bool &value, const IPosition &where)
| Put the value of a single element.
virtual void | copyData (const Lattice< Bool > &from)
| Copy the data from the given lattice to this one.
Public Member Functions inherited from casacore::LCRegion
| LCRegion ()
| LCRegion (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegion (const LCRegion &other)
| Copy constructor (copy semantics).
virtual | ~LCRegion ()
Bool | operator!= (const LCRegion &other) const
| Non-equality.
virtual Lattice< Bool > * | clone () const
| Make a copy of the derived object.
const String & | comment () const
| Get or set the comment.
void | setComment (const String &comment)
LCRegion * | translate (const IPosition &translateVector) const
| Construct another LCRegion (for e.g.
LCRegion * | translate (const IPosition &translateVector, const IPosition &newLatticeShape) const
LCRegion * | translate (const Vector< Float > &translateVector) const
LCRegion * | translate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
const IPosition & | latticeShape () const
| Give the full lattice shape.
const Slicer & | boundingBox () const
| Give the bounding box.
Slicer | expand (const Slicer &slicer) const
| Expand a slicer or position in the region to the full lattice.
IPosition | expand (const IPosition &index) const
virtual uInt | ndim () const
| Return the dimensionality of the region.
virtual IPosition | shape () const
| Return the shape of the region (i.e.
Public Member Functions inherited from casacore::Lattice< Bool >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
Bool | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual Bool | getAt (const IPosition &where) const
Bool | get (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | put (const Array< Bool > &sourceBuffer)
void | operator+= (const Lattice< Bool > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< Bool > &other)
void | operator*= (const Lattice< Bool > &other)
void | operator/= (const Lattice< Bool > &other)
virtual void | copyDataTo (Lattice< Bool > &to) const
| Copy the data from this lattice to the given lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.

## Static Public Member Functions

static String | className ()
| Get the class name (to store in the record).
static LCPagedMask * | fromRecord (const TableRecord &, const String &tablename)
| Convert correct object from a record.
Static Public Member Functions inherited from casacore::LCRegion
static LCRegion * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.

## Protected Member Functions

virtual LCRegion * | doTranslate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
| Construct another LCPagedMask (for e.g.
Protected Member Functions inherited from casacore::LCRegionSingle
LCRegionSingle & | operator= (const LCRegionSingle &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setMaskPtr (Lattice< Bool > &mask)
| Set the pointer to the mask in the derived class.
virtual Bool | doGetSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual getting of the mask.
virtual void | doPutSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Do the actual putting of the mask.
Protected Member Functions inherited from casacore::LCRegion
LCRegion & | operator= (const LCRegion &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setBoundingBox (const Slicer &boundingBox)
| Sometimes it is inconvenient for a derived class to set the bounding box in the constructor.
void | setShapeAndBoundingBox (const IPosition &latticeShape, const Slicer &boundingBox)
void | defineRecordFields (RecordInterface &record, const String &className) const
| Define the type and class name in the record.
Protected Member Functions inherited from casacore::Lattice< Bool >
void | handleMathTo (Lattice< Bool > &, int) const
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< Bool > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
Lattice< Bool > & | operator= (const Lattice< Bool > &)
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Member Functions

| LCPagedMask (PagedArray< Bool > &mask, const IPosition &blc, const IPosition &latticeShape)
| Create the object from a record (for an existing mask).

## Private Attributes

LCBox | itsBox
PagedArray< Bool > | itsMask

## Detailed Description

Class to define a rectangular mask as a region

### Intended use:

Public interface

### Prerequisite

- LCRegion

### Synopsis

The LCPagedMask class is a specialization of class LCRegion.

### Example

Definition at line 64 of file LCPagedMask.h.

## Constructor & Destructor Documentation

## LCPagedMask() [1/6]

casacore::LCPagedMask::LCPagedMask | ( |  | ) |

Referenced by fromRecord(), LCPagedMask(), and operator=().

## LCPagedMask() [2/6]

casacore::LCPagedMask::LCPagedMask | ( | const TiledShape & | latticeShape,
|  | const String & | tableName )

Construct a PagedMask object for (part of) a lattice.

The box defines the position of the mask. The default mask shape is the lattice shape.

References casacore::LCRegion::latticeShape().

## LCPagedMask() [3/6]

casacore::LCPagedMask::LCPagedMask | ( | const TiledShape & | maskShape,
|  | const LCBox & | box,
|  | const String & | tableName )

## LCPagedMask() [4/6]

casacore::LCPagedMask::LCPagedMask | ( | PagedArray< Bool > & | mask,
|  | const LCBox & | box )

References casacore::mask().

## LCPagedMask() [5/6]

casacore::LCPagedMask::LCPagedMask | ( | const LCPagedMask & | other | ) |

Copy constructor (copy semantics).

References LCPagedMask().

## ~LCPagedMask()

virtual casacore::LCPagedMask::~LCPagedMask | ( |  | ) |

virtual

Destructor.

## LCPagedMask() [6/6]

casacore::LCPagedMask::LCPagedMask | ( | PagedArray< Bool > & | mask,
|  | const IPosition & | blc,
|  | const IPosition & | latticeShape )

private

Create the object from a record (for an existing mask).

References casacore::LCRegion::latticeShape(), and casacore::mask().

## Member Function Documentation

## advisedMaxPixels()

virtual uInt casacore::LCPagedMask::advisedMaxPixels | ( |  | ) | const

virtual

Returns the maximum recommended number of pixels for a cursor.

This is the number of pixels in a tile.

Reimplemented from casacore::Lattice< Bool >.

## className()

String casacore::LCPagedMask::className | ( |  | ) |

static

Get the class name (to store in the record).

## clearCache()

virtual void casacore::LCPagedMask::clearCache | ( |  | ) |

virtual

Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.

Reimplemented from casacore::LatticeBase.

## cloneRegion()

virtual LCRegion * casacore::LCPagedMask::cloneRegion | ( |  | ) | const

virtual

Make a copy of the derived object.

Implements casacore::LCRegion.

## doNiceCursorShape()

virtual IPosition casacore::LCPagedMask::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Help the user pick a cursor for most efficient access.

Reimplemented from casacore::LCRegionSingle.

## doTranslate()

virtual LCRegion * casacore::LCPagedMask::doTranslate | ( | const Vector< Float > & | translateVector,
|  | const IPosition & | newLatticeShape ) const

protected virtual

Construct another LCPagedMask (for e.g.

another lattice) by moving this one. It recalculates the bounding mask. A positive translation value indicates "to right".

Implements casacore::LCRegion.

## flush()

virtual void casacore::LCPagedMask::flush | ( |  | ) |

virtual

Flush the data (but do not unlock).

Reimplemented from casacore::LatticeBase.

## fromRecord()

LCPagedMask * casacore::LCPagedMask::fromRecord | ( | const TableRecord & | ,
|  | const String & | tablename )

static

Convert correct object from a record.

References LCPagedMask().

## handleDelete()

virtual void casacore::LCPagedMask::handleDelete | ( |  | ) |

virtual

Handle deletion of the region by deleting the associated table.

Reimplemented from casacore::LCRegion.

## handleRename()

virtual void casacore::LCPagedMask::handleRename | ( | const String & | newName,
|  | Bool | overwrite )

virtual

Handle renaming the region by renaming the associated table.

If overwrite=False, an exception will be thrown if a table with the new name already exists.

Reimplemented from casacore::LCRegion.

## hasLock()

virtual Bool casacore::LCPagedMask::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LatticeBase.

## isWritable()

virtual Bool casacore::LCPagedMask::isWritable | ( |  | ) | const

virtual

An LCPagedMask is writable if the underlying PagedArray is.

Reimplemented from casacore::LCRegion.

## lock()

virtual Bool casacore::LCPagedMask::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle the (un)locking.

Reimplemented from casacore::LatticeBase.

## makeIter()

virtual LatticeIterInterface< Bool > * casacore::LCPagedMask::makeIter | ( | const LatticeNavigator & | navigator,
|  | Bool | useRef ) const

virtual

This function is used by the LatticeIterator class to generate an iterator of the correct type for this Lattice.

Not recommended for general use.

Reimplemented from casacore::LCRegionSingle.

## maximumCacheSize()

virtual uInt casacore::LCPagedMask::maximumCacheSize | ( |  | ) | const

virtual

Maximum size - not necessarily all used.

In pixels.

Reimplemented from casacore::LatticeBase.

## operator=()

LCPagedMask & casacore::LCPagedMask::operator= | ( | const LCPagedMask & | other | ) |

Assignment (reference semantics).

References LCPagedMask().

## operator==()

virtual Bool casacore::LCPagedMask::operator== | ( | const LCRegion & | other | ) | const

virtual

Comparison.

Reimplemented from casacore::LCRegion.

## reopen()

virtual void casacore::LCPagedMask::reopen | ( |  | ) |

virtual

Explicitly reopen the temporarily closed lattice.

Reimplemented from casacore::LatticeBase.

## resync()

virtual void casacore::LCPagedMask::resync | ( |  | ) |

virtual

Resynchronize the PagedArray object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.

Reimplemented from casacore::LatticeBase.

## setCacheSizeFromPath()

virtual void casacore::LCPagedMask::setCacheSizeFromPath | ( | const IPosition & | sliceShape,
|  | const IPosition & | windowStart,
|  | const IPosition & | windowLength,
|  | const IPosition & | axisPath )

virtual

Set the cache size as to "fit" the indicated path.

Reimplemented from casacore::LatticeBase.

## setCacheSizeInTiles()

virtual void casacore::LCPagedMask::setCacheSizeInTiles | ( | uInt | howManyTiles | ) |

virtual

Set the actual cache size for this Array to be be big enough for the indicated number of tiles.

This cache is not shared with PagedArrays in other rows and is always clipped to be less than the maximum value set using the setMaximumCacheSize member function. tiles. Tiles are cached using a first in first out algorithm.

Reimplemented from casacore::LatticeBase.

## setMaximumCacheSize()

virtual void casacore::LCPagedMask::setMaximumCacheSize | ( | uInt | howManyPixels | ) |

virtual

Set the maximum (allowed) cache size as indicated.

Reimplemented from casacore::LatticeBase.

## showCacheStatistics()

virtual void casacore::LCPagedMask::showCacheStatistics | ( | ostream & | os | ) | const

virtual

Report on cache success.

Reimplemented from casacore::LatticeBase.

## tempClose()

virtual void casacore::LCPagedMask::tempClose | ( |  | ) |

virtual

Temporarily close the lattice.

It will be reopened automatically on the next access.

Reimplemented from casacore::LatticeBase.

## toRecord()

virtual TableRecord casacore::LCPagedMask::toRecord | ( | const String & | tableName | ) | const

virtual

Convert the (derived) object to a record.

Implements casacore::LCRegion.

## type()

virtual String casacore::LCPagedMask::type | ( |  | ) | const

virtual

Region type.

Returns class name.

Implements casacore::LCRegion.

## unlock()

virtual void casacore::LCPagedMask::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LatticeBase.

## Member Data Documentation

## itsBox

LCBox casacore::LCPagedMask::itsBox

private

Definition at line 196 of file LCPagedMask.h.

## itsMask

PagedArray<Bool> casacore::LCPagedMask::itsMask

private

Definition at line 197 of file LCPagedMask.h.

The documentation for this class was generated from the following file:

- lattices/LRegions/LCPagedMask.h